import type { AnyConstructor } from '@angular-three/core';
import { ThreeObject3d } from '@angular-three/core';
import { ThreeBufferGeometry } from '@angular-three/core/geometries';
import { ThreeMaterial } from '@angular-three/core/materials';
import { AfterContentInit } from '@angular/core';
import { BufferGeometry, Material, Mesh } from 'three';
export declare abstract class ThreeMesh<TMesh extends Mesh = Mesh> extends ThreeObject3d<TMesh> implements AfterContentInit {
    geometry?: string | BufferGeometry | null;
    material?: string | Material | null;
    morphTargetInfluences?: number[];
    morphTargetDictionary?: {
        [key: string]: number;
    };
    materialDirective?: ThreeMaterial;
    bufferGeometryDirective?: ThreeBufferGeometry;
    abstract meshType: AnyConstructor<TMesh>;
    private _mesh;
    private _extraArgs?;
    set extraArgs(v: unknown[]);
    ngAfterContentInit(): void;
    protected initObject(): void;
    protected customize?: () => void;
    protected canCreate(): boolean;
    get object3d(): TMesh;
}
